/*
	File: DissolveSans.h

	Copyright (c) 1990, Thomas Knoll.
	Copyright (c) 1991-6, Adobe Systems Incorporated.
	All rights reserved.

	Header file for DissolveSans example.
*/

#ifndef __DissolveSans_H__
#define __DissolveSans_H__

#include "PIFilter.h"
#include "PIUtilities.h"

/*****************************************************************************/

#define useAlpha 			0	// use alpha

#define kPercentMin			1
#define kPercentMax			99

#define keyDisposition 		'disP'
#define keyEntireImage		'entI'
#define typeMood			'mooD'
#define dispositionClear	'moD0'
#define dispositionCool		'moD1'
#define dispositionHot		'moD2'
#define dispositionSick		'moD3'

#define kEditText	 		3	
#define kProxyItem			5
#define	kFirstRadio			7
#define kLastRadio			10
#define kEntireImage		11

#define kGutter				2 // 2 pixel gutter for border

enum
	{
		dialogDispositionClear,
		dialogDispositionCool,
		dialogDispositionHot,
		dialogDispositionSick
	};

/*****************************************************************************/

typedef struct TParameters
	{
	short percent;
	short queryForParameters;
	short rowSkip;
	OSType disposition;
	Boolean ignoreSelection;
	Boolean useAdvance;
	Boolean hostIsPremiereWin;
	} TParameters, *PParameters, **HParameters;

#define gParams 			((PParameters) *gStuff->parameters)
#define gPercent			(gParams->percent)
#define gQueryForParameters	(gParams->queryForParameters)
#define gDisposition 		(gParams->disposition)
#define gIgnoreSelection 	(gParams->ignoreSelection)
#define gUseAdvance			(gParams->useAdvance)
#define gRowSkip			(gParams->rowSkip)
#define gHostIsPremiereWin	(gParams->hostIsPremiereWin)

/*****************************************************************************/

extern Handle hDllInstance;

typedef struct Globals
	{
	short result;
	Rect	proxyRect;
	FilterRecord *filterParamBlock;
	} Globals, *GPtr, **GHdl;
	
#define gResult 	(globals->result)
#define gStuff  	(globals->filterParamBlock)
#define gProxyRect	(globals->proxyRect)

/*****************************************************************************/

void DoAbout (GPtr globals);
void scaleRect(Rect *l, short n, short d);
void shrinkRect(Rect *l, short x, short y);
void copyRect(Rect *l, Rect *r);
short PromptUserForInput (GPtr globals);
void CalcProxyScaleFactor (const Rect *filterRect, Rect *proxyRect, short *scaleFactor);
void DoFilterRect (GPtr globals, const Boolean useProgress);
void SetupFilterRecordForProxy (GPtr globals);	 
void BuildProxy (GPtr globals);
short GetDisposition (OSType disposition);
void SetDisposition (GPtr globals, short dispositionEnum);
void ValidateParameters (GPtr globals);
Boolean ReadScriptParams (GPtr globals);
OSErr WriteScriptParams (GPtr globals);
void StartWithAdvanceState (GPtr globals);
void StartNoAdvanceState (GPtr globals);
void DoInitialRect (GPtr globals);
void DoFilterRectNoAdvanceState (GPtr globals);
Boolean DoNextRect (GPtr globals);
void DispatchFilterRect (GPtr globals, const Boolean useProgress);
void SetColor (GPtr globals,
				unsigned8 *dstPtr,
				unsigned8 c0,
				unsigned8 c1,
				unsigned8 c2,
				unsigned8 c3,
				int16 *planes);

/*****************************************************************************/

#endif /* __DissolveSans_H__ */