#
#       File: DissolveSans Plugin Makefile
# Filter .8BF
#

TARGET  = DissolveSans
UTILDIR = D:\!CodeWork\Examples\Resources
SOURCES = D:\!CodeWork\Examples\Common\Sources.c
OBJECTS = ..\DissolveSans.obj DissolveSansUIWin.obj ..\DissolveSansScripting.obj $(SOURCES)\PIUtilities.obj $(SOURCES)\WinUtilities.obj $(SOURCES)\WinDialogUtils.obj

all: $(TARGET).8BF

PSDLLENTRY=DLLInit
TYPE=8BF

OS=NT
ENV=WIN32

!INCLUDE <$(OS)$(ENV).MAK>

.SUFFIXES: .cpp .c

INCLUDES = /I.. /I..\..\Common\Rez-files.r /I..\..\Common\Sources.c /I..\..\Common\Headers.h

!ifdef nodebug
OPTIM=-Ox -G5
!else
OPTIM=-Zi -Od
!endif

COMMON=-nologo -DMSDOS -DMSWindows=1 $(cflags) $(cvars) $(LOCAL_CFLAGS) $(OPTIM) $(INCLUDES)

.cpp.obj :
    $(cc) $(COMMON) -Fo$*.obj $*.cpp

.c.obj :
    $(cc) $(COMMON) -Fo$*.obj $*.c

.rc.res :
    $(rc) $(rcvars) $(INCLUDES) -r -fo$*.res $(cvars) $*.rc

.res.rbj :
	cvtres -$(CPU) $*.res -o $*.rbj

# Define the dependencies for the RC file. 	Dissolve.RC includes PiPL.RSC
$(TARGET).RC: PiPL.RSC
# Made the dependency an include in the .RC file spec at compile time

# Define the dependencies for PiPL.RSC. PiPL is auto-generated by CnvtPiPL.EXE 
# taking PiPL.TMP as input
PiPL.RSC: PIPL.TMP
	$(UTILDIR)\cnvtpipl PiPL.TMP PiPL.RSC

# Define the dependencies for PiPL.TMP. PiPL.TMP is generated by C Pre-Processor 
# taking <plug-in>.r as input
PIPL.TMP: ..\$(TARGET).R
    $(cc) $(INCLUDES) /EP /DMSWindows=1 /Tc..\$(TARGET).R > PiPL.TMP

clean :
    -del *.obj
    -del *.rbj
    -del *.res
    -del *.err		
	-del *.exp
    -del $(TARGET).$(TYPE)

#  Generate import library (.lib) and export library (.exp)
#  from a module-definition (.def) file for a DLL
$(TARGET).lib $(TARGET).exp : $(TARGET).def
    LIB /out:$(TARGET).lib /machine:$(CPU) $(OBJECTS) /def:$(TARGET).def



$(TARGET).$(TYPE): $(TARGET).res $(OBJECTS) $(TARGET).exp
    $(link) @<<
$(ldebug)
/dll
/entry:$(PSDLLENTRY)$(DLLENTRY)
/out:$*.$(TYPE)
$(guilibsdll)
$(OBJECTS)
$(TARGET).res
$(TARGET).exp
<<NOKEEP

